# Bare Metal Solution API

Provides ways to manage Bare Metal Solution hardware installed in a regional extension located near a Google Cloud data center.

- [REST Resource: v2.projects.locations](https://docs.cloud.google.com/bare-metal/docs/reference/rest#v2.projects.locations)
- [REST Resource: v2.projects.locations.instances](https://docs.cloud.google.com/bare-metal/docs/reference/rest#v2.projects.locations.instances)
- [REST Resource: v2.projects.locations.networks](https://docs.cloud.google.com/bare-metal/docs/reference/rest#v2.projects.locations.networks)
- [REST Resource: v2.projects.locations.nfsShares](https://docs.cloud.google.com/bare-metal/docs/reference/rest#v2.projects.locations.nfsShares)
- [REST Resource: v2.projects.locations.operations](https://docs.cloud.google.com/bare-metal/docs/reference/rest#v2.projects.locations.operations)
- [REST Resource: v2.projects.locations.volumes](https://docs.cloud.google.com/bare-metal/docs/reference/rest#v2.projects.locations.volumes)
- [REST Resource: v2.projects.locations.volumes.luns](https://docs.cloud.google.com/bare-metal/docs/reference/rest#v2.projects.locations.volumes.luns)
- [REST Resource: v2.projects.locations.volumes.snapshots](https://docs.cloud.google.com/bare-metal/docs/reference/rest#v2.projects.locations.volumes.snapshots)

## Service: baremetalsolution.googleapis.com

To call this service, we recommend that you use the Google-provided [client libraries](https://cloud.google.com/apis/docs/client-libraries-explained). If your application needs to use your own libraries to call this service, use the following information when you make the API requests.

### Discovery document

A [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) is a machine-readable specification for describing and consuming REST APIs. It is used to build client libraries, IDE plugins, and other tools that interact with Google APIs. One service may provide multiple discovery documents. This service provides the following discovery document:

- <https://baremetalsolution.googleapis.com/$discovery/rest?version=v2>

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://baremetalsolution.googleapis.com`

## REST Resource: [v2.projects.locations](https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations/get` | `GET /v2/{name=projects/*/locations/*}` Gets information about a location. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations/list` | `GET /v2/{name=projects/*}/locations` Lists information about the supported locations for this service. |

## REST Resource: [v2.projects.locations.instances](https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/create` | `POST /v2/{parent=projects/*/locations/*}/instances` Create an Instance. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/detachLun` | `POST /v2/{instance=projects/*/locations/*/instances/*}:detachLun` Detach LUN from Instance. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/get` | `GET /v2/{name=projects/*/locations/*/instances/*}` Get details about a single server. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/list` | `GET /v2/{parent=projects/*/locations/*}/instances` List servers in a given project and location. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/patch` | `PATCH /v2/{instance.name=projects/*/locations/*/instances/*}` Update details of a single server. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/rename` | `POST /v2/{name=projects/*/locations/*/instances/*}:rename` RenameInstance sets a new name for an instance. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/reset` | `POST /v2/{name=projects/*/locations/*/instances/*}:reset` Perform an ungraceful, hard reset on a server. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/start` | `POST /v2/{name=projects/*/locations/*/instances/*}:start` Starts a server that was shutdown. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.instances/stop` | `POST /v2/{name=projects/*/locations/*/instances/*}:stop` Stop a running server. |

## REST Resource: [v2.projects.locations.networks](https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.networks)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.networks/get` | `GET /v2/{name=projects/*/locations/*/networks/*}` Get details of a single network. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.networks/list` | `GET /v2/{parent=projects/*/locations/*}/networks` List network in a given project and location. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.networks/patch` | `PATCH /v2/{network.name=projects/*/locations/*/networks/*}` Update details of a single network. |

## REST Resource: [v2.projects.locations.nfsShares](https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.nfsShares)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.nfsShares/create` | `POST /v2/{parent=projects/*/locations/*}/nfsShares` Create an NFS share. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.nfsShares/delete` | `DELETE /v2/{name=projects/*/locations/*/nfsShares/*}` Delete an NFS share. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.nfsShares/get` | `GET /v2/{name=projects/*/locations/*/nfsShares/*}` Get details of a single NFS share. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.nfsShares/list` | `GET /v2/{parent=projects/*/locations/*}/nfsShares` List NFS shares. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.nfsShares/patch` | `PATCH /v2/{nfsShare.name=projects/*/locations/*/nfsShares/*}` Update details of a single NFS share. |

## REST Resource: [v2.projects.locations.operations](https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.operations)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.operations/get` | `GET /v2/{name=projects/*/locations/*/operations/**}` Get details about an operation. |

## REST Resource: [v2.projects.locations.volumes](https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes/evict` | `POST /v2/{name=projects/*/locations/*/volumes/*}:evict` Skips volume's cooloff and deletes it now. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes/get` | `GET /v2/{name=projects/*/locations/*/volumes/*}` Get details of a single storage volume. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes/list` | `GET /v2/{parent=projects/*/locations/*}/volumes` List storage volumes in a given project and location. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes/patch` | `PATCH /v2/{volume.name=projects/*/locations/*/volumes/*}` Update details of a single storage volume. |

## REST Resource: [v2.projects.locations.volumes.luns](https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.luns)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.luns/evict` | `POST /v2/{name=projects/*/locations/*/volumes/*/luns/*}:evict` Skips lun's cooloff and deletes it now. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.luns/get` | `GET /v2/{name=projects/*/locations/*/volumes/*/luns/*}` Get details of a single storage logical unit number(LUN). |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.luns/list` | `GET /v2/{parent=projects/*/locations/*/volumes/*}/luns` List storage volume luns for given storage volume. |

## REST Resource: [v2.projects.locations.volumes.snapshots](https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.snapshots)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.snapshots/create` | `POST /v2/{parent=projects/*/locations/*/volumes/*}/snapshots` Takes a snapshot of a boot volume. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.snapshots/delete` | `DELETE /v2/{name=projects/*/locations/*/volumes/*/snapshots/*}` Deletes a volume snapshot. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.snapshots/get` | `GET /v2/{name=projects/*/locations/*/volumes/*/snapshots/*}` Returns the specified snapshot resource. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.snapshots/list` | `GET /v2/{parent=projects/*/locations/*/volumes/*}/snapshots` Retrieves the list of snapshots for the specified volume. |
| `https://docs.cloud.google.com/bare-metal/docs/reference/rest/v2/projects.locations.volumes.snapshots/restoreVolumeSnapshot` | `POST /v2/{volumeSnapshot=projects/*/locations/*/volumes/*/snapshots/*}:restoreVolumeSnapshot` Uses the specified snapshot to restore its parent volume. |